<?php

/**
 * actualizar_contrato actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage actualizar_contrato
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class actualizar_contratoActions extends sfActions {

    /**
     * Incidente #35119, Actualizar datos de contrato
     * 
      Modificar No total de pagos y el plazo de ejecución.
      Modificar la forma de pago, cuándo desde contratos y convenios no se aclara (aplica para primeros pagos).
      Modificar Aplica estampilla
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------* Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        $records = array();

        /**
         * Abrir nueva conexion con la Base de Datos
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Formato de fecha
         */
        //Sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD" 
EOD;
        //Ejecutar SQL
        CN_TABLE::executeSQL($sql);

        try {

            /*
             * Variables de filtro
             */
            //Periodo
            $id_contrato = $request['id_contrato'];

            $numero_pago = $request['numero_pago'];
            $meses_plazo = $request['meses_plazo'];
            $dias_plazo = $request['dias_plazo'];

            $aplica_estampilla = $request['aplica_estampilla'];
            $valor_primer_pago = $request['valor_primer_pago'];

            if ($aplica_estampilla === 'true') {
                $aplica_estampilla = 1;
                $id_benef_estampilla = $request['id_benef_estampilla'];
            } else {
                $aplica_estampilla = 0;
                $id_benef_estampilla = '';
            }
            
            //Camops nuevo y valores por defecto estampilla - 20240307::LAVILA
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * variables por defecto para el registro de log
             */
            $id_tabla = $request['id_contrato'];

            /*
             * obtener id maestro tabla
             */
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('RVC_CONTRATO');

            /**
              1	CONSULTAR
              2	ACTUALIZAR
              3	ADICIONAR
              4	ELIMINAR
              5	ANULAR
             */
            $id_ope_bd = 2;

            //id del maestro tercero
            $id_mae_ter = 1;
            if (isset($request['id_username'])) {
                $id_mae_ter = $request['id_username'];
            }

            //username
            $username = 'admin';
            if (isset($request['username'])) {
                if (!is_null($request['username']) && $request['username'] != '') {
                    $username = $request['username'];
                }
            }

            //comando de la funcionalidad
            $comando = 'sin comando';
            if (isset($request['comando'])) {
                $comando = $request['comando'];
            }

            //construir observacion
            $observacion_log = "'Se actualizo tablas de contratos RVC y Contratacion'";

            /*
             * registro de consulta en tabla de log
             */
            $sql = CN_TABLE::registroTableLog($id_tabla, $id_ope_bd, $id_mae_bd, $id_mae_ter, $username, $comando, $observacion_log);


            //Modificar co_contrato
            $sql = <<<EOD
update co_contrato 
set aplica_estampilla = nvl('$aplica_estampilla',0), id_benef_estampilla = '$id_benef_estampilla', valor_primer_pago = nvl('$valor_primer_pago',0) 
where id_contrato in (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
            //Ejecutar SQL
            $this->conn->execute($sql);

            //Modificar rvc_contrato
            $sql = <<<EOD
update rvc_contrato 
set numero_pago = $numero_pago, meses_plazo = $meses_plazo, dias_plazo = $dias_plazo, fecha_ini = to_date('$fecha_ini','yyyy-mm-dd'), fecha_fin = to_date('$fecha_fin','yyyy-mm-dd') 
where id_contrato = $id_contrato
EOD;
            //Ejecutar SQL
            $this->conn->execute($sql);

            //Modificar rvc_acta_inicio
            $sql = <<<EOD
update rvc_acta_inicio 
set numero_pago = $numero_pago, meses_plazo = $meses_plazo, dias_plazo = $dias_plazo, fecha_ini = to_date('$fecha_ini','yyyy-mm-dd'), fecha_fin = to_date('$fecha_fin','yyyy-mm-dd') 
where id_contrato = $id_contrato
EOD;
            //Ejecutar SQL
            $this->conn->execute($sql);

            /**
             * Genera log
             */
            /**
              1	CONSULTAR
              2	ACTUALIZAR
              3	ADICIONAR
              4	ELIMINAR
              5	ANULAR
             */
            $id_ope_bd = 2;

            //construir observacion
            $observacion_log = "'[actualizar_contrato] Genera actualización de contratos RVC'";

            /*
             * registro de consulta en tabla de log
             */
            $sql = CN_TABLE::registroTableLog($id_tabla, $id_ope_bd, $id_mae_bd, $id_mae_ter, $username, $comando, $observacion_log);


            /*
             * COMMIT DE TODAS LAS TRANSACCIONES
             */
            $this->conn->commit();
            $this->status = 0;
            $this->list_data = array();
            $this->logMessage("[actualizar_contrato] Actualización exitosa");
        } catch (Exception $e) {

            /*
             * ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
             */
            $this->conn->rollback();
            $this->status = 1;
            $this->mensajeError = "[actualizar_contrato] Ocurrio un error: " . $e->getMessage();
            $this->list_data = array();
            $this->logMessage("[actualizar_contrato] ERROR!");
            $this->logMessage($e->getMessage());
        }
    }

}
